Index: dvblast.c
===================================================================
--- dvblast.c	(révision 182)
+++ dvblast.c	(copie de travail)
@@ -1,7 +1,7 @@
 /*****************************************************************************
  * dvblast.c
  *****************************************************************************
- * Copyright (C) 2004, 2008-2010 VideoLAN
+ * Copyright (C) 2004, 2008-2011 VideoLAN
  * $Id$
  *
  * Authors: Christophe Massiot <massiot@via.ecp.fr>
@@ -78,7 +78,9 @@
 mtime_t i_frontend_timeout_duration = DEFAULT_FRONTEND_TIMEOUT;
 mtime_t i_quit_timeout = 0;
 mtime_t i_quit_timeout_duration = 0;
-int b_budget_mode = 0;
+//int b_budget_mode = 0;
+int b_budget_mode = 1;
+int b_any_type = 0;
 int b_select_pmts = 0;
 int b_random_tsid = 0;
 uint16_t i_network_id = 0xffff;
@@ -381,7 +383,7 @@
 void usage()
 {
     DisplayVersion();
-    msg_Raw( NULL, "Usage: dvblast [-q] [-c <config file>] [-r <remote socket>] [-t <ttl>] [-o <SSRC IP>] [-i <RT priority>] [-a <adapter>] [-n <frontend number>] [-S <diseqc>] [-f <frequency>|-D [<src host>[:<src port>]@]<src mcast>[:<port>][/<opts>]*|-A <ASI adapter>] [-s <symbol rate>] [-v <0|13|18>] [-p] [-b <bandwidth>] [-I <inversion>] [-F <fec inner>] [-m <modulation] [-R <rolloff>] [-P <pilot>] [-K <fec lp>] [-G <guard interval>] [-H <hierarchy>] [-X <transmission>] [-O <lock timeout>] [-u] [-w] [-U] [-L <latency>] [-E <retention>] [-d <dest IP>[<:port>][/<opts>]*] [-C [-e] [-M <network name] [-N <network ID>]] [-T] [-j <system charset>] [-J <DVB charset>] [-Q <quit timeout>] [-x <text|xml>" );
+    msg_Raw( NULL, "Usage: dvblast [-q] [-c <config file>] [-r <remote socket>] [-t <ttl>] [-o <SSRC IP>] [-i <RT priority>] [-a <adapter>] [-n <frontend number>] [-S <diseqc>] [-f <frequency>|-D [<src host>[:<src port>]@]<src mcast>[:<port>][/<opts>]*|-A <ASI adapter>] [-s <symbol rate>] [-v <0|13|18>] [-p] [-b <bandwidth>] [-I <inversion>] [-F <fec inner>] [-m <modulation] [-R <rolloff>] [-P <pilot>] [-K <fec lp>] [-G <guard interval>] [-H <hierarchy>] [-X <transmission>] [-O <lock timeout>] [-u] [-w] [-U] [-L <latency>] [-E <retention>] [-d <dest IP>[<:port>][/<opts>]*] [-z] [-C [-e] [-M <network name] [-N <network ID>]] [-T] [-j <system charset>] [-J <DVB charset>] [-Q <quit timeout>] [-x <text|xml>]" );
 
     msg_Raw( NULL, "Input:" );
     msg_Raw( NULL, "  -a --adapter          read packets from a Linux-DVB adapter (typically 0-n)" );
@@ -426,6 +428,7 @@
     msg_Raw( NULL, "  -t --ttl <ttl>        TTL of the output stream" );
     msg_Raw( NULL, "  -T --unique-ts-id     generate random unique TS ID for each output" );
     msg_Raw( NULL, "  -U --udp              use raw UDP rather than RTP (required by some IPTV set top boxes)" );
+    msg_Raw( NULL, "  -z --any-type         pass through all ESs from the PMT, of any type" );
 
     msg_Raw( NULL, "Misc:" );
     msg_Raw( NULL, "  -h --help             display this full help" );
@@ -493,6 +496,7 @@
         { "duplicate",       required_argument, NULL, 'd' },
         { "rtp-input",       required_argument, NULL, 'D' },
         { "asi-adapter",     required_argument, NULL, 'A' },
+        { "any-type",        no_argument,       NULL, 'z' },
         { "dvb-compliance",  no_argument,       NULL, 'C' },
         { "epg-passthrough", no_argument,       NULL, 'e' },
         { "network-name",    no_argument,       NULL, 'M' },
@@ -508,7 +512,7 @@
         { 0, 0, 0, 0 }
     };
 
-    while ( (c = getopt_long(i_argc, pp_argv, "q::c:r:t:o:i:a:n:f:F:R:s:S:v:pb:I:m:P:K:G:H:X:O:uwUTL:E:d:D:A:lCeM:N:j:J:x:Q:hV", long_options, NULL)) != -1 )
+    while ( (c = getopt_long(i_argc, pp_argv, "q::c:r:t:o:i:a:n:f:F:R:s:S:v:pb:I:m:P:K:G:H:X:O:uwUTL:E:d:D:A:lzCeM:N:j:J:x:Q:hV", long_options, NULL)) != -1 )
     {
         switch ( c )
         {
@@ -700,6 +704,10 @@
             pf_UnsetFilter = asi_UnsetFilter;
             break;
 
+        case 'z':
+            b_any_type = 1;
+            break;
+
         case 'C':
             b_dvb_global = 1;
             break;
Index: en50221.c
===================================================================
--- en50221.c	(révision 184)
+++ en50221.c	(copie de travail)
@@ -20,7 +20,7 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA    02111, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
  *****************************************************************************/
 
 #include <stdlib.h>
@@ -2219,6 +2219,22 @@
 }
 
 /*****************************************************************************
+ * en50221_ReloadPMT :
+ *****************************************************************************/
+void en50221_ReloadPMT( uint8_t *p_pmt )
+{
+    int i_session_id;
+
+    for ( i_session_id = 1; i_session_id <= MAX_SESSIONS; i_session_id++ )
+        if ( p_sessions[i_session_id - 1].i_resource_id
+                == RI_CONDITIONAL_ACCESS_SUPPORT )
+        {
+            CAPMTDelete( NULL, i_session_id, p_pmt );
+            CAPMTAdd( NULL, i_session_id, p_pmt );
+        }
+}
+
+/*****************************************************************************
  * en50221_StatusMMI :
  *****************************************************************************/
 uint8_t en50221_StatusMMI( uint8_t *p_answer, ssize_t *pi_size )
Index: en50221.h
===================================================================
--- en50221.h	(révision 183)
+++ en50221.h	(copie de travail)
@@ -75,6 +75,7 @@
 void en50221_AddPMT( uint8_t *p_pmt );
 void en50221_UpdatePMT( uint8_t *p_pmt );
 void en50221_DeletePMT( uint8_t *p_pmt );
+void en50221_ReloadPMT( uint8_t *p_pmt );
 uint8_t en50221_StatusMMI( uint8_t *p_answer, ssize_t *pi_size );
 uint8_t en50221_StatusMMISlot( uint8_t *p_buffer, ssize_t i_size,
                                uint8_t *p_answer, ssize_t *pi_size );
